/// This is where the magic happens; program your plug-in's core behavior here.

#include "game_hooks.h"
#include <graphics/graphics.h>
#include <SCBW/api.h>
#include <SCBW/scbwdata.h>
#include <SCBW/ExtendSightLimit.h>
#include "psi_field.h"
#include <cstdio>

// N sec * 24 frm/sec = BROODLINGCOLONY_TIMER
#define BROODLINGCOLONY_TIMER 10 * 24

namespace hooks {

/// This hook is called every frame; most of your plugin's logic goes here.
bool nextFrame() {
  if (!scbw::isGamePaused()) { //If the game is not paused
    scbw::setInGameLoopState(true); //Needed for scbw::random() to work
    graphics::resetAllGraphics();
    hooks::updatePsiFieldProviders();
    
    //This block is executed once every game.
    if (*elapsedTimeFrames == 0) {
      //Write your code here
      //scbw::printText(PLUGIN_NAME ": Hello, world!");
    }

    //Loop through all visible units in the game.
    for (CUnit *unit = *firstVisibleUnit; unit; unit = unit->link.next) {
      //Write your code here
    }

	for (CUnit *unith = *firstHiddenUnit; unith; unith = unith->link.next)
	{
		if (unith->id == UnitId::broodling
			&& unith->mainOrderId != OrderId::Die
			&& unith->removeTimer != BROODLINGCOLONY_TIMER) {
			//scbw::printText("unith found and modded");
			unith->removeTimer = BROODLINGCOLONY_TIMER;
		}
	}

    scbw::setInGameLoopState(false);
  }
  return true;
}

bool gameOn() {
  return true;
}

bool gameEnd() {
  return true;
}

} //hooks
